
#line 1 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
#include <assert.h>
#include <ruby.h>

#if defined(_WIN32)
#include <stddef.h>
#endif

#ifdef HAVE_RUBY_RE_H
#include <ruby/re.h>
#else
#include <re.h>
#endif

#ifdef HAVE_RUBY_ENCODING_H
#include <ruby/encoding.h>
#define ENCODED_STR_NEW(ptr, len) \
    rb_enc_str_new(ptr, len, rb_utf8_encoding())
#else
#define ENCODED_STR_NEW(ptr, len) \
    rb_str_new(ptr, len)
#endif

#ifndef RSTRING_PTR
#define RSTRING_PTR(s) (RSTRING(s)->ptr)
#endif

#ifndef RSTRING_LEN
#define RSTRING_LEN(s) (RSTRING(s)->len)
#endif

#define DATA_GET(FROM, TYPE, NAME) \
  Data_Get_Struct(FROM, TYPE, NAME); \
  if (NAME == NULL) { \
    rb_raise(rb_eArgError, "NULL found for " # NAME " when it shouldn't be."); \
  }
 
typedef struct lexer_state {
  int content_len;
  int line_number;
  int current_line;
  int start_col;
  size_t mark;
  size_t keyword_start;
  size_t keyword_end;
  size_t next_keyword_start;
  size_t content_start;
  size_t content_end;
  size_t docstring_content_type_start;
  size_t docstring_content_type_end;
  size_t query_start;
  size_t last_newline;
  size_t final_newline;
} lexer_state;

static VALUE mGherkin;
static VALUE mGherkinLexer;
static VALUE mCLexer;
static VALUE cI18nLexer;
static VALUE rb_eGherkinLexingError;

#define LEN(AT, P) (P - data - lexer->AT)
#define MARK(M, P) (lexer->M = (P) - data)
#define PTR_TO(P) (data + lexer->P)

#define STORE_KW_END_CON(EVENT) \
  store_multiline_kw_con(listener, # EVENT, \
    PTR_TO(keyword_start), LEN(keyword_start, PTR_TO(keyword_end - 1)), \
    PTR_TO(content_start), LEN(content_start, PTR_TO(content_end)), \
    lexer->current_line, lexer->start_col); \
    if (lexer->content_end != 0) { \
      p = PTR_TO(content_end - 1); \
    } \
    lexer->content_end = 0

#define STORE_ATTR(ATTR) \
    store_attr(listener, # ATTR, \
      PTR_TO(content_start), LEN(content_start, p), \
      lexer->line_number)


#line 254 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"


/** Data **/

#line 89 "ext/gherkin_lexer_hi/gherkin_lexer_hi.c"
static const char _lexer_actions[] = {
	0, 1, 0, 1, 1, 1, 2, 1, 
	3, 1, 4, 1, 5, 1, 6, 1, 
	7, 1, 8, 1, 9, 1, 10, 1, 
	11, 1, 12, 1, 13, 1, 16, 1, 
	17, 1, 18, 1, 19, 1, 20, 1, 
	21, 1, 22, 1, 23, 2, 1, 18, 
	2, 4, 5, 2, 13, 0, 2, 14, 
	15, 2, 17, 0, 2, 17, 2, 2, 
	17, 16, 2, 17, 19, 2, 18, 6, 
	2, 18, 7, 2, 18, 8, 2, 18, 
	9, 2, 18, 10, 2, 18, 16, 2, 
	20, 21, 2, 22, 0, 2, 22, 2, 
	2, 22, 16, 2, 22, 19, 3, 3, 
	14, 15, 3, 5, 14, 15, 3, 11, 
	14, 15, 3, 12, 14, 15, 3, 13, 
	14, 15, 3, 14, 15, 18, 3, 17, 
	0, 11, 3, 17, 14, 15, 4, 1, 
	14, 15, 18, 4, 4, 5, 14, 15, 
	4, 17, 0, 14, 15, 5, 17, 0, 
	11, 14, 15
};

static const short _lexer_key_offsets[] = {
	0, 0, 12, 13, 22, 23, 24, 25, 
	26, 27, 28, 29, 31, 33, 44, 45, 
	46, 48, 50, 55, 60, 65, 70, 74, 
	78, 80, 81, 82, 83, 84, 85, 86, 
	87, 88, 89, 90, 91, 92, 93, 94, 
	95, 100, 107, 112, 116, 122, 125, 127, 
	133, 144, 145, 146, 147, 148, 149, 150, 
	151, 152, 153, 154, 155, 156, 157, 158, 
	159, 160, 161, 162, 169, 171, 173, 175, 
	177, 179, 181, 183, 185, 187, 189, 191, 
	193, 195, 197, 199, 201, 203, 205, 207, 
	218, 219, 220, 221, 222, 223, 224, 225, 
	226, 227, 228, 229, 230, 231, 232, 233, 
	234, 235, 237, 238, 239, 240, 241, 243, 
	244, 246, 247, 248, 249, 250, 251, 252, 
	253, 254, 255, 256, 257, 258, 259, 260, 
	261, 262, 263, 265, 266, 267, 268, 269, 
	270, 271, 272, 273, 274, 275, 276, 277, 
	278, 279, 280, 281, 282, 283, 284, 285, 
	286, 287, 288, 289, 298, 300, 309, 311, 
	313, 315, 317, 319, 321, 323, 325, 327, 
	329, 331, 333, 335, 337, 339, 341, 343, 
	345, 347, 349, 351, 353, 355, 357, 360, 
	362, 364, 366, 368, 370, 372, 375, 377, 
	379, 381, 383, 385, 387, 389, 391, 393, 
	395, 397, 399, 401, 403, 405, 407, 409, 
	411, 413, 415, 417, 419, 421, 423, 425, 
	427, 429, 431, 433, 435, 437, 439, 441, 
	443, 445, 447, 449, 451, 453, 455, 457, 
	459, 461, 463, 465, 467, 469, 471, 473, 
	475, 477, 478, 479, 488, 490, 499, 501, 
	503, 505, 507, 509, 511, 513, 515, 517, 
	519, 521, 523, 525, 527, 529, 531, 533, 
	535, 537, 539, 541, 543, 545, 547, 550, 
	552, 554, 556, 558, 561, 563, 566, 568, 
	570, 572, 574, 576, 578, 580, 582, 584, 
	586, 588, 590, 592, 594, 596, 598, 600, 
	603, 605, 607, 609, 611, 613, 615, 617, 
	619, 621, 623, 625, 627, 629, 631, 633, 
	635, 637, 639, 641, 643, 645, 647, 649, 
	651, 653, 655, 657, 659, 661, 663, 665, 
	667, 669, 671, 673, 675, 677, 679, 681, 
	683, 685, 687, 689, 691, 693, 695, 697, 
	699, 701, 703, 705, 707, 709, 711, 713, 
	715, 717, 719, 721, 723, 725, 727, 729, 
	731, 733, 735, 737, 739, 741, 743, 745, 
	747, 749, 751, 753, 755, 757, 758, 759, 
	760, 761, 762, 763, 764, 765, 766, 767, 
	768, 769, 770, 771, 772, 773, 774, 775, 
	776, 777, 778, 779, 780, 781, 782, 791, 
	793, 802, 804, 806, 808, 810, 812, 814, 
	816, 818, 820, 822, 824, 826, 828, 830, 
	832, 834, 836, 838, 840, 842, 844, 846, 
	848, 850, 853, 855, 857, 859, 861, 863, 
	865, 868, 870, 872, 874, 876, 878, 880, 
	882, 884, 886, 888, 890, 892, 894, 896, 
	898, 900, 902, 905, 907, 909, 911, 913, 
	915, 917, 919, 921, 923, 925, 927, 929, 
	931, 933, 935, 937, 939, 941, 943, 945, 
	947, 949, 951, 953, 955, 957, 959, 961, 
	963, 965, 967, 969, 971, 973, 975, 977, 
	979, 981, 983, 985, 987, 989, 991, 993, 
	995, 997, 999, 1001, 1003, 1005, 1007, 1009, 
	1011, 1013, 1015, 1016, 1017, 1018, 1019, 1020, 
	1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 
	1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036, 
	1037, 1045, 1047, 1051, 1053, 1055, 1057, 1059, 
	1061, 1063, 1065, 1067, 1069, 1071, 1073, 1075, 
	1077, 1079, 1081, 1083, 1085, 1088, 1090, 1092, 
	1094, 1096, 1098, 1100, 1102, 1104, 1106, 1108, 
	1110, 1112, 1114, 1116, 1118, 1120, 1122, 1124, 
	1126, 1129, 1131, 1133, 1135, 1137, 1139, 1141, 
	1143, 1145, 1147, 1149, 1151, 1153, 1155, 1157, 
	1159, 1161, 1163, 1165, 1167, 1169, 1171, 1173, 
	1175, 1177, 1179, 1181, 1183, 1185, 1187, 1189, 
	1191, 1193, 1195, 1197, 1199, 1201, 1203, 1205, 
	1207, 1209, 1211, 1213, 1215, 1217, 1219, 1221, 
	1223, 1225, 1227, 1229, 1231, 1233, 1235, 1237, 
	1239, 1241, 1243, 1245, 1247, 1249, 1251, 1253, 
	1255, 1257, 1259, 1261, 1263, 1265, 1267, 1269, 
	1271, 1273, 1275, 1276, 1277
};

static const char _lexer_trans_keys[] = {
	-32, -17, 10, 32, 34, 35, 37, 42, 
	64, 124, 9, 13, -92, -123, -119, -108, 
	-102, -100, -92, -86, -81, -80, -32, -92, 
	-105, -32, -92, -80, 32, 10, 13, 10, 
	13, -32, 10, 32, 34, 35, 37, 42, 
	64, 124, 9, 13, 34, 34, 10, 13, 
	10, 13, 10, 32, 34, 9, 13, 10, 
	32, 34, 9, 13, 10, 32, 34, 9, 
	13, 10, 32, 34, 9, 13, 10, 32, 
	9, 13, 10, 32, 9, 13, 10, 13, 
	10, 95, 70, 69, 65, 84, 85, 82, 
	69, 95, 69, 78, 68, 95, 37, 13, 
	32, 64, 9, 10, 9, 10, 13, 32, 
	64, 11, 12, 10, 32, 64, 9, 13, 
	32, 124, 9, 13, 10, 32, 92, 124, 
	9, 13, 10, 92, 124, 10, 92, 10, 
	32, 92, 124, 9, 13, -32, 10, 32, 
	34, 35, 37, 42, 64, 124, 9, 13, 
	-32, -92, -90, -32, -92, -66, -32, -92, 
	-71, -32, -92, -80, -32, -92, -93, 58, 
	10, 10, -32, 10, 32, 35, 124, 9, 
	13, -92, 10, -80, 10, -32, 10, -91, 
	10, -126, 10, -32, 10, -92, 10, -86, 
	10, 10, 32, -32, 10, -92, 10, -78, 
	10, -32, 10, -91, 10, -121, 10, -32, 
	10, -92, 10, -106, 10, 10, 58, -32, 
	10, 32, 34, 35, 37, 42, 64, 124, 
	9, 13, -32, -91, -126, -32, -92, -126, 
	-32, -92, -107, -32, -92, -65, -32, -92, 
	-84, -32, -92, -91, -84, -32, -92, -66, 
	-32, -92, -91, -80, -32, 32, -92, -65, 
	-32, -92, -90, -32, -91, -125, -32, -92, 
	-74, -32, -91, -115, -32, -92, -81, 32, 
	58, -32, -92, -80, -32, -91, -126, -32, 
	-92, -86, -32, -92, -80, -32, -91, -121, 
	-32, -92, -106, -32, -92, -66, 58, 10, 
	10, -32, 10, 32, 35, 37, 42, 64, 
	9, 13, -92, 10, -123, -108, -102, -100, 
	-92, -86, -81, -80, 10, -32, 10, -92, 
	10, -105, 10, -32, 10, -92, 10, -80, 
	10, 10, 32, -32, 10, -91, 10, -126, 
	10, -32, 10, -92, 10, -126, 10, -32, 
	10, -92, 10, -107, 10, -32, 10, -92, 
	10, -65, 10, -32, 10, -92, 10, -84, 
	10, -32, 10, -92, 10, -91, -84, 10, 
	-32, 10, -92, 10, -66, 10, -32, 10, 
	-92, 10, -80, 10, -32, 10, 32, -92, 
	10, -65, 10, -32, 10, -92, 10, -90, 
	10, -32, 10, -91, 10, -125, 10, -32, 
	10, -92, 10, -74, 10, -32, 10, -91, 
	10, -115, 10, -32, 10, -92, 10, -81, 
	10, 10, 58, -32, 10, -92, 10, -90, 
	10, -32, 10, -91, 10, -126, 10, -32, 
	10, -92, 10, -86, 10, 10, 32, -32, 
	10, -92, 10, -78, 10, -32, 10, -91, 
	10, -121, 10, -32, 10, -92, 10, -106, 
	10, 10, 95, 10, 70, 10, 69, 10, 
	65, 10, 84, 10, 85, 10, 82, 10, 
	69, 10, 95, 10, 69, 10, 78, 10, 
	68, 10, 95, 10, 37, 10, 10, -32, 
	10, 32, 35, 37, 42, 64, 9, 13, 
	-92, 10, -123, -108, -102, -100, -92, -86, 
	-81, -80, 10, -32, 10, -92, 10, -105, 
	10, -32, 10, -92, 10, -80, 10, 10, 
	32, -32, 10, -91, 10, -126, 10, -32, 
	10, -92, 10, -126, 10, -32, 10, -92, 
	10, -107, 10, -32, 10, -92, 10, -65, 
	10, -32, 10, -92, 10, -84, 10, -32, 
	10, -92, 10, -91, -84, 10, -32, 10, 
	-92, 10, -66, 10, -32, 10, -92, -91, 
	10, -80, 10, -32, 10, 32, -92, 10, 
	-65, 10, -32, 10, -92, 10, -90, 10, 
	-32, 10, -91, 10, -125, 10, -32, 10, 
	-92, 10, -74, 10, -32, 10, -91, 10, 
	-115, 10, -32, 10, -92, 10, -81, 10, 
	10, 32, 58, -32, 10, -92, 10, -80, 
	10, -32, 10, -91, 10, -126, 10, -32, 
	10, -92, 10, -86, 10, -32, 10, -92, 
	10, -80, 10, -32, 10, -91, 10, -121, 
	10, -32, 10, -92, 10, -106, 10, -32, 
	10, -92, 10, -66, 10, 10, 58, -125, 
	10, -32, 10, -92, 10, -73, 10, -32, 
	10, -91, 10, -115, 10, -32, 10, -92, 
	10, -96, 10, -32, 10, -92, 10, -83, 
	10, -32, 10, -91, 10, -126, 10, -32, 
	10, -92, 10, -82, 10, -32, 10, -92, 
	10, -65, 10, -32, 10, -92, 10, -90, 
	10, -32, 10, -91, 10, -126, 10, -32, 
	10, -92, 10, -86, 10, 10, 32, -32, 
	10, -92, 10, -78, 10, -32, 10, -91, 
	10, -121, 10, -32, 10, -92, 10, -106, 
	10, 10, 95, 10, 70, 10, 69, 10, 
	65, 10, 84, 10, 85, 10, 82, 10, 
	69, 10, 95, 10, 69, 10, 78, 10, 
	68, 10, 95, 10, 37, -125, -32, -92, 
	-73, -32, -91, -115, -32, -92, -96, -32, 
	-92, -83, -32, -91, -126, -32, -92, -82, 
	-32, -92, -65, 58, 10, 10, -32, 10, 
	32, 35, 37, 42, 64, 9, 13, -92, 
	10, -123, -108, -102, -100, -92, -86, -81, 
	-80, 10, -32, 10, -92, 10, -105, 10, 
	-32, 10, -92, 10, -80, 10, 10, 32, 
	-32, 10, -91, 10, -126, 10, -32, 10, 
	-92, 10, -126, 10, -32, 10, -92, 10, 
	-107, 10, -32, 10, -92, 10, -65, 10, 
	-32, 10, -92, 10, -84, 10, -32, 10, 
	-92, 10, -91, -84, 10, -32, 10, -92, 
	10, -66, 10, -32, 10, -92, 10, -80, 
	10, -32, 10, 32, -92, 10, -65, 10, 
	-32, 10, -92, 10, -90, 10, -32, 10, 
	-91, 10, -125, 10, -32, 10, -92, 10, 
	-74, 10, -32, 10, -91, 10, -115, 10, 
	-32, 10, -92, 10, -81, 10, 10, 32, 
	58, -32, 10, -92, 10, -80, 10, -32, 
	10, -91, 10, -126, 10, -32, 10, -92, 
	10, -86, 10, -32, 10, -92, 10, -80, 
	10, -32, 10, -91, 10, -121, 10, -32, 
	10, -92, 10, -106, 10, -32, 10, -92, 
	10, -66, 10, 10, 58, -32, 10, -92, 
	10, -90, 10, -32, 10, -91, 10, -126, 
	10, -32, 10, -92, 10, -86, 10, 10, 
	32, -32, 10, -92, 10, -78, 10, -32, 
	10, -91, 10, -121, 10, -32, 10, -92, 
	10, -106, 10, 10, 95, 10, 70, 10, 
	69, 10, 65, 10, 84, 10, 85, 10, 
	82, 10, 69, 10, 95, 10, 69, 10, 
	78, 10, 68, 10, 95, 10, 37, -32, 
	-92, -90, -32, -91, -126, -32, -92, -86, 
	32, -32, -92, -78, -32, -91, -121, -32, 
	-92, -106, 58, 10, 10, -32, 10, 32, 
	35, 37, 64, 9, 13, -92, 10, -119, 
	-86, -80, 10, -32, 10, -92, 10, -90, 
	10, -32, 10, -92, 10, -66, 10, -32, 
	10, -92, 10, -71, 10, -32, 10, -92, 
	10, -80, 10, -32, 10, -92, 10, -93, 
	10, 10, 58, -32, 10, -92, -91, 10, 
	-80, 10, -32, 10, -92, 10, -65, 10, 
	-32, 10, -92, 10, -90, 10, -32, 10, 
	-91, 10, -125, 10, -32, 10, -92, 10, 
	-74, 10, -32, 10, -91, 10, -115, 10, 
	-32, 10, -92, 10, -81, 10, 10, 32, 
	58, -32, 10, -92, 10, -80, 10, -32, 
	10, -91, 10, -126, 10, -32, 10, -92, 
	10, -86, 10, -32, 10, -92, 10, -80, 
	10, -32, 10, -91, 10, -121, 10, -32, 
	10, -92, 10, -106, 10, -32, 10, -92, 
	10, -66, 10, -125, 10, -32, 10, -92, 
	10, -73, 10, -32, 10, -91, 10, -115, 
	10, -32, 10, -92, 10, -96, 10, -32, 
	10, -92, 10, -83, 10, -32, 10, -91, 
	10, -126, 10, -32, 10, -92, 10, -82, 
	10, -32, 10, -92, 10, -65, 10, -32, 
	10, -91, 10, -126, 10, -32, 10, -92, 
	10, -86, 10, 10, 32, -32, 10, -92, 
	10, -78, 10, -32, 10, -91, 10, -121, 
	10, -32, 10, -92, 10, -106, 10, 10, 
	95, 10, 70, 10, 69, 10, 65, 10, 
	84, 10, 85, 10, 82, 10, 69, 10, 
	95, 10, 69, 10, 78, 10, 68, 10, 
	95, 10, 37, -69, -65, 0
};

static const char _lexer_single_lengths[] = {
	0, 10, 1, 9, 1, 1, 1, 1, 
	1, 1, 1, 2, 2, 9, 1, 1, 
	2, 2, 3, 3, 3, 3, 2, 2, 
	2, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	3, 5, 3, 2, 4, 3, 2, 4, 
	9, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 5, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 9, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 2, 1, 1, 1, 1, 2, 1, 
	2, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 2, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 7, 2, 9, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 3, 2, 
	2, 2, 2, 2, 2, 3, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 1, 1, 7, 2, 9, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 3, 2, 
	2, 2, 2, 3, 2, 3, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 3, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 7, 2, 
	9, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 3, 2, 2, 2, 2, 2, 2, 
	3, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 3, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	6, 2, 4, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 3, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	3, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 1, 1, 0
};

static const char _lexer_range_lengths[] = {
	0, 1, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 1, 0, 0, 
	0, 0, 1, 1, 1, 1, 1, 1, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	1, 1, 1, 1, 1, 0, 0, 1, 
	1, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 1, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 1, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 1, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 1, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 1, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	1, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0
};

static const short _lexer_index_offsets[] = {
	0, 0, 12, 14, 24, 26, 28, 30, 
	32, 34, 36, 38, 41, 44, 55, 57, 
	59, 62, 65, 70, 75, 80, 85, 89, 
	93, 96, 98, 100, 102, 104, 106, 108, 
	110, 112, 114, 116, 118, 120, 122, 124, 
	126, 131, 138, 143, 147, 153, 157, 160, 
	166, 177, 179, 181, 183, 185, 187, 189, 
	191, 193, 195, 197, 199, 201, 203, 205, 
	207, 209, 211, 213, 220, 223, 226, 229, 
	232, 235, 238, 241, 244, 247, 250, 253, 
	256, 259, 262, 265, 268, 271, 274, 277, 
	288, 290, 292, 294, 296, 298, 300, 302, 
	304, 306, 308, 310, 312, 314, 316, 318, 
	320, 322, 325, 327, 329, 331, 333, 336, 
	338, 341, 343, 345, 347, 349, 351, 353, 
	355, 357, 359, 361, 363, 365, 367, 369, 
	371, 373, 375, 378, 380, 382, 384, 386, 
	388, 390, 392, 394, 396, 398, 400, 402, 
	404, 406, 408, 410, 412, 414, 416, 418, 
	420, 422, 424, 426, 435, 438, 448, 451, 
	454, 457, 460, 463, 466, 469, 472, 475, 
	478, 481, 484, 487, 490, 493, 496, 499, 
	502, 505, 508, 511, 514, 517, 520, 524, 
	527, 530, 533, 536, 539, 542, 546, 549, 
	552, 555, 558, 561, 564, 567, 570, 573, 
	576, 579, 582, 585, 588, 591, 594, 597, 
	600, 603, 606, 609, 612, 615, 618, 621, 
	624, 627, 630, 633, 636, 639, 642, 645, 
	648, 651, 654, 657, 660, 663, 666, 669, 
	672, 675, 678, 681, 684, 687, 690, 693, 
	696, 699, 701, 703, 712, 715, 725, 728, 
	731, 734, 737, 740, 743, 746, 749, 752, 
	755, 758, 761, 764, 767, 770, 773, 776, 
	779, 782, 785, 788, 791, 794, 797, 801, 
	804, 807, 810, 813, 817, 820, 824, 827, 
	830, 833, 836, 839, 842, 845, 848, 851, 
	854, 857, 860, 863, 866, 869, 872, 875, 
	879, 882, 885, 888, 891, 894, 897, 900, 
	903, 906, 909, 912, 915, 918, 921, 924, 
	927, 930, 933, 936, 939, 942, 945, 948, 
	951, 954, 957, 960, 963, 966, 969, 972, 
	975, 978, 981, 984, 987, 990, 993, 996, 
	999, 1002, 1005, 1008, 1011, 1014, 1017, 1020, 
	1023, 1026, 1029, 1032, 1035, 1038, 1041, 1044, 
	1047, 1050, 1053, 1056, 1059, 1062, 1065, 1068, 
	1071, 1074, 1077, 1080, 1083, 1086, 1089, 1092, 
	1095, 1098, 1101, 1104, 1107, 1110, 1112, 1114, 
	1116, 1118, 1120, 1122, 1124, 1126, 1128, 1130, 
	1132, 1134, 1136, 1138, 1140, 1142, 1144, 1146, 
	1148, 1150, 1152, 1154, 1156, 1158, 1160, 1169, 
	1172, 1182, 1185, 1188, 1191, 1194, 1197, 1200, 
	1203, 1206, 1209, 1212, 1215, 1218, 1221, 1224, 
	1227, 1230, 1233, 1236, 1239, 1242, 1245, 1248, 
	1251, 1254, 1258, 1261, 1264, 1267, 1270, 1273, 
	1276, 1280, 1283, 1286, 1289, 1292, 1295, 1298, 
	1301, 1304, 1307, 1310, 1313, 1316, 1319, 1322, 
	1325, 1328, 1331, 1335, 1338, 1341, 1344, 1347, 
	1350, 1353, 1356, 1359, 1362, 1365, 1368, 1371, 
	1374, 1377, 1380, 1383, 1386, 1389, 1392, 1395, 
	1398, 1401, 1404, 1407, 1410, 1413, 1416, 1419, 
	1422, 1425, 1428, 1431, 1434, 1437, 1440, 1443, 
	1446, 1449, 1452, 1455, 1458, 1461, 1464, 1467, 
	1470, 1473, 1476, 1479, 1482, 1485, 1488, 1491, 
	1494, 1497, 1500, 1502, 1504, 1506, 1508, 1510, 
	1512, 1514, 1516, 1518, 1520, 1522, 1524, 1526, 
	1528, 1530, 1532, 1534, 1536, 1538, 1540, 1542, 
	1544, 1552, 1555, 1560, 1563, 1566, 1569, 1572, 
	1575, 1578, 1581, 1584, 1587, 1590, 1593, 1596, 
	1599, 1602, 1605, 1608, 1611, 1615, 1618, 1621, 
	1624, 1627, 1630, 1633, 1636, 1639, 1642, 1645, 
	1648, 1651, 1654, 1657, 1660, 1663, 1666, 1669, 
	1672, 1676, 1679, 1682, 1685, 1688, 1691, 1694, 
	1697, 1700, 1703, 1706, 1709, 1712, 1715, 1718, 
	1721, 1724, 1727, 1730, 1733, 1736, 1739, 1742, 
	1745, 1748, 1751, 1754, 1757, 1760, 1763, 1766, 
	1769, 1772, 1775, 1778, 1781, 1784, 1787, 1790, 
	1793, 1796, 1799, 1802, 1805, 1808, 1811, 1814, 
	1817, 1820, 1823, 1826, 1829, 1832, 1835, 1838, 
	1841, 1844, 1847, 1850, 1853, 1856, 1859, 1862, 
	1865, 1868, 1871, 1874, 1877, 1880, 1883, 1886, 
	1889, 1892, 1895, 1897, 1899
};

static const short _lexer_trans_targs[] = {
	2, 642, 13, 13, 14, 24, 26, 10, 
	40, 43, 13, 0, 3, 0, 4, 49, 
	7, 88, 100, 103, 109, 506, 509, 0, 
	5, 0, 6, 0, 7, 0, 8, 0, 
	9, 0, 10, 0, 11, 0, 13, 25, 
	12, 13, 25, 12, 2, 13, 13, 14, 
	24, 26, 10, 40, 43, 13, 0, 15, 
	0, 16, 0, 18, 17, 17, 18, 17, 
	17, 19, 19, 20, 19, 19, 19, 19, 
	20, 19, 19, 19, 19, 21, 19, 19, 
	19, 19, 22, 19, 19, 13, 23, 23, 
	0, 13, 23, 23, 0, 13, 25, 24, 
	13, 0, 27, 0, 28, 0, 29, 0, 
	30, 0, 31, 0, 32, 0, 33, 0, 
	34, 0, 35, 0, 36, 0, 37, 0, 
	38, 0, 39, 0, 644, 0, 0, 0, 
	0, 0, 41, 42, 13, 42, 42, 40, 
	41, 41, 13, 42, 40, 42, 0, 43, 
	44, 43, 0, 48, 47, 46, 44, 47, 
	45, 0, 46, 44, 45, 0, 46, 45, 
	48, 47, 46, 44, 47, 45, 2, 48, 
	48, 14, 24, 26, 10, 40, 43, 48, 
	0, 50, 0, 51, 0, 52, 0, 53, 
	0, 54, 0, 55, 0, 56, 0, 57, 
	0, 58, 0, 59, 0, 60, 0, 61, 
	0, 62, 0, 63, 0, 64, 0, 65, 
	0, 67, 66, 67, 66, 68, 67, 67, 
	13, 13, 67, 66, 69, 67, 66, 70, 
	67, 66, 71, 67, 66, 72, 67, 66, 
	73, 67, 66, 74, 67, 66, 75, 67, 
	66, 76, 67, 66, 67, 77, 66, 78, 
	67, 66, 79, 67, 66, 80, 67, 66, 
	81, 67, 66, 82, 67, 66, 83, 67, 
	66, 84, 67, 66, 85, 67, 66, 86, 
	67, 66, 67, 87, 66, 2, 13, 13, 
	14, 24, 26, 10, 40, 43, 13, 0, 
	89, 0, 90, 0, 91, 0, 92, 0, 
	93, 0, 94, 0, 95, 0, 96, 0, 
	97, 0, 98, 0, 99, 0, 10, 0, 
	101, 0, 102, 0, 10, 0, 104, 0, 
	105, 0, 106, 10, 0, 107, 0, 108, 
	0, 10, 0, 110, 0, 111, 373, 0, 
	112, 0, 113, 11, 0, 114, 0, 115, 
	0, 116, 0, 117, 0, 118, 0, 119, 
	0, 120, 0, 121, 0, 122, 0, 123, 
	0, 124, 0, 125, 0, 126, 0, 127, 
	0, 128, 0, 129, 0, 130, 0, 131, 
	241, 0, 132, 0, 133, 0, 134, 0, 
	135, 0, 136, 0, 137, 0, 138, 0, 
	139, 0, 140, 0, 141, 0, 142, 0, 
	143, 0, 144, 0, 145, 0, 146, 0, 
	147, 0, 148, 0, 149, 0, 150, 0, 
	151, 0, 152, 0, 153, 0, 155, 154, 
	155, 154, 156, 155, 155, 13, 227, 164, 
	13, 155, 154, 157, 155, 154, 158, 161, 
	165, 177, 180, 186, 208, 211, 155, 154, 
	159, 155, 154, 160, 155, 154, 161, 155, 
	154, 162, 155, 154, 163, 155, 154, 164, 
	155, 154, 155, 87, 154, 166, 155, 154, 
	167, 155, 154, 168, 155, 154, 169, 155, 
	154, 170, 155, 154, 171, 155, 154, 172, 
	155, 154, 173, 155, 154, 174, 155, 154, 
	175, 155, 154, 176, 155, 154, 164, 155, 
	154, 178, 155, 154, 179, 155, 154, 164, 
	155, 154, 181, 155, 154, 182, 155, 154, 
	183, 164, 155, 154, 184, 155, 154, 185, 
	155, 154, 164, 155, 154, 187, 155, 154, 
	188, 155, 154, 189, 155, 154, 190, 155, 
	87, 154, 191, 155, 154, 192, 155, 154, 
	193, 155, 154, 194, 155, 154, 195, 155, 
	154, 196, 155, 154, 197, 155, 154, 198, 
	155, 154, 199, 155, 154, 200, 155, 154, 
	201, 155, 154, 202, 155, 154, 203, 155, 
	154, 204, 155, 154, 205, 155, 154, 206, 
	155, 154, 207, 155, 154, 155, 87, 154, 
	209, 155, 154, 210, 155, 154, 174, 155, 
	154, 212, 155, 154, 213, 155, 154, 214, 
	155, 154, 215, 155, 154, 216, 155, 154, 
	217, 155, 154, 155, 218, 154, 219, 155, 
	154, 220, 155, 154, 221, 155, 154, 222, 
	155, 154, 223, 155, 154, 224, 155, 154, 
	225, 155, 154, 226, 155, 154, 207, 155, 
	154, 155, 228, 154, 155, 229, 154, 155, 
	230, 154, 155, 231, 154, 155, 232, 154, 
	155, 233, 154, 155, 234, 154, 155, 235, 
	154, 155, 236, 154, 155, 237, 154, 155, 
	238, 154, 155, 239, 154, 155, 240, 154, 
	155, 13, 154, 243, 242, 243, 242, 244, 
	243, 243, 13, 359, 252, 13, 243, 242, 
	245, 243, 242, 246, 249, 253, 265, 268, 
	274, 340, 343, 243, 242, 247, 243, 242, 
	248, 243, 242, 249, 243, 242, 250, 243, 
	242, 251, 243, 242, 252, 243, 242, 243, 
	87, 242, 254, 243, 242, 255, 243, 242, 
	256, 243, 242, 257, 243, 242, 258, 243, 
	242, 259, 243, 242, 260, 243, 242, 261, 
	243, 242, 262, 243, 242, 263, 243, 242, 
	264, 243, 242, 252, 243, 242, 266, 243, 
	242, 267, 243, 242, 252, 243, 242, 269, 
	243, 242, 270, 243, 242, 271, 252, 243, 
	242, 272, 243, 242, 273, 243, 242, 252, 
	243, 242, 275, 243, 242, 276, 318, 243, 
	242, 277, 243, 242, 278, 243, 87, 242, 
	279, 243, 242, 280, 243, 242, 281, 243, 
	242, 282, 243, 242, 283, 243, 242, 284, 
	243, 242, 285, 243, 242, 286, 243, 242, 
	287, 243, 242, 288, 243, 242, 289, 243, 
	242, 290, 243, 242, 291, 243, 242, 292, 
	243, 242, 293, 243, 242, 294, 243, 242, 
	295, 243, 242, 243, 296, 87, 242, 297, 
	243, 242, 298, 243, 242, 299, 243, 242, 
	300, 243, 242, 301, 243, 242, 302, 243, 
	242, 303, 243, 242, 304, 243, 242, 305, 
	243, 242, 306, 243, 242, 307, 243, 242, 
	308, 243, 242, 309, 243, 242, 310, 243, 
	242, 311, 243, 242, 312, 243, 242, 313, 
	243, 242, 314, 243, 242, 315, 243, 242, 
	316, 243, 242, 317, 243, 242, 243, 87, 
	242, 319, 243, 242, 320, 243, 242, 321, 
	243, 242, 322, 243, 242, 323, 243, 242, 
	324, 243, 242, 325, 243, 242, 326, 243, 
	242, 327, 243, 242, 328, 243, 242, 329, 
	243, 242, 330, 243, 242, 331, 243, 242, 
	332, 243, 242, 333, 243, 242, 334, 243, 
	242, 335, 243, 242, 336, 243, 242, 337, 
	243, 242, 338, 243, 242, 339, 243, 242, 
	317, 243, 242, 341, 243, 242, 342, 243, 
	242, 262, 243, 242, 344, 243, 242, 345, 
	243, 242, 346, 243, 242, 347, 243, 242, 
	348, 243, 242, 349, 243, 242, 243, 350, 
	242, 351, 243, 242, 352, 243, 242, 353, 
	243, 242, 354, 243, 242, 355, 243, 242, 
	356, 243, 242, 357, 243, 242, 358, 243, 
	242, 317, 243, 242, 243, 360, 242, 243, 
	361, 242, 243, 362, 242, 243, 363, 242, 
	243, 364, 242, 243, 365, 242, 243, 366, 
	242, 243, 367, 242, 243, 368, 242, 243, 
	369, 242, 243, 370, 242, 243, 371, 242, 
	243, 372, 242, 243, 13, 242, 374, 0, 
	375, 0, 376, 0, 377, 0, 378, 0, 
	379, 0, 380, 0, 381, 0, 382, 0, 
	383, 0, 384, 0, 385, 0, 386, 0, 
	387, 0, 388, 0, 389, 0, 390, 0, 
	391, 0, 392, 0, 393, 0, 394, 0, 
	395, 0, 396, 0, 398, 397, 398, 397, 
	399, 398, 398, 13, 492, 407, 13, 398, 
	397, 400, 398, 397, 401, 404, 408, 420, 
	423, 429, 473, 476, 398, 397, 402, 398, 
	397, 403, 398, 397, 404, 398, 397, 405, 
	398, 397, 406, 398, 397, 407, 398, 397, 
	398, 87, 397, 409, 398, 397, 410, 398, 
	397, 411, 398, 397, 412, 398, 397, 413, 
	398, 397, 414, 398, 397, 415, 398, 397, 
	416, 398, 397, 417, 398, 397, 418, 398, 
	397, 419, 398, 397, 407, 398, 397, 421, 
	398, 397, 422, 398, 397, 407, 398, 397, 
	424, 398, 397, 425, 398, 397, 426, 407, 
	398, 397, 427, 398, 397, 428, 398, 397, 
	407, 398, 397, 430, 398, 397, 431, 398, 
	397, 432, 398, 397, 433, 398, 87, 397, 
	434, 398, 397, 435, 398, 397, 436, 398, 
	397, 437, 398, 397, 438, 398, 397, 439, 
	398, 397, 440, 398, 397, 441, 398, 397, 
	442, 398, 397, 443, 398, 397, 444, 398, 
	397, 445, 398, 397, 446, 398, 397, 447, 
	398, 397, 448, 398, 397, 449, 398, 397, 
	450, 398, 397, 398, 451, 87, 397, 452, 
	398, 397, 453, 398, 397, 454, 398, 397, 
	455, 398, 397, 456, 398, 397, 457, 398, 
	397, 458, 398, 397, 459, 398, 397, 460, 
	398, 397, 461, 398, 397, 462, 398, 397, 
	463, 398, 397, 464, 398, 397, 465, 398, 
	397, 466, 398, 397, 467, 398, 397, 468, 
	398, 397, 469, 398, 397, 470, 398, 397, 
	471, 398, 397, 472, 398, 397, 398, 87, 
	397, 474, 398, 397, 475, 398, 397, 417, 
	398, 397, 477, 398, 397, 478, 398, 397, 
	479, 398, 397, 480, 398, 397, 481, 398, 
	397, 482, 398, 397, 398, 483, 397, 484, 
	398, 397, 485, 398, 397, 486, 398, 397, 
	487, 398, 397, 488, 398, 397, 489, 398, 
	397, 490, 398, 397, 491, 398, 397, 472, 
	398, 397, 398, 493, 397, 398, 494, 397, 
	398, 495, 397, 398, 496, 397, 398, 497, 
	397, 398, 498, 397, 398, 499, 397, 398, 
	500, 397, 398, 501, 397, 398, 502, 397, 
	398, 503, 397, 398, 504, 397, 398, 505, 
	397, 398, 13, 397, 507, 0, 508, 0, 
	97, 0, 510, 0, 511, 0, 512, 0, 
	513, 0, 514, 0, 515, 0, 516, 0, 
	517, 0, 518, 0, 519, 0, 520, 0, 
	521, 0, 522, 0, 523, 0, 524, 0, 
	525, 0, 526, 0, 528, 527, 528, 527, 
	529, 528, 528, 13, 628, 13, 528, 527, 
	530, 528, 527, 531, 547, 612, 528, 527, 
	532, 528, 527, 533, 528, 527, 534, 528, 
	527, 535, 528, 527, 536, 528, 527, 537, 
	528, 527, 538, 528, 527, 539, 528, 527, 
	540, 528, 527, 541, 528, 527, 542, 528, 
	527, 543, 528, 527, 544, 528, 527, 545, 
	528, 527, 546, 528, 527, 528, 87, 527, 
	548, 528, 527, 549, 590, 528, 527, 550, 
	528, 527, 551, 528, 527, 552, 528, 527, 
	553, 528, 527, 554, 528, 527, 555, 528, 
	527, 556, 528, 527, 557, 528, 527, 558, 
	528, 527, 559, 528, 527, 560, 528, 527, 
	561, 528, 527, 562, 528, 527, 563, 528, 
	527, 564, 528, 527, 565, 528, 527, 566, 
	528, 527, 567, 528, 527, 568, 528, 527, 
	528, 569, 87, 527, 570, 528, 527, 571, 
	528, 527, 572, 528, 527, 573, 528, 527, 
	574, 528, 527, 575, 528, 527, 576, 528, 
	527, 577, 528, 527, 578, 528, 527, 579, 
	528, 527, 580, 528, 527, 581, 528, 527, 
	582, 528, 527, 583, 528, 527, 584, 528, 
	527, 585, 528, 527, 586, 528, 527, 587, 
	528, 527, 588, 528, 527, 589, 528, 527, 
	546, 528, 527, 591, 528, 527, 592, 528, 
	527, 593, 528, 527, 594, 528, 527, 595, 
	528, 527, 596, 528, 527, 597, 528, 527, 
	598, 528, 527, 599, 528, 527, 600, 528, 
	527, 601, 528, 527, 602, 528, 527, 603, 
	528, 527, 604, 528, 527, 605, 528, 527, 
	606, 528, 527, 607, 528, 527, 608, 528, 
	527, 609, 528, 527, 610, 528, 527, 611, 
	528, 527, 546, 528, 527, 613, 528, 527, 
	614, 528, 527, 615, 528, 527, 616, 528, 
	527, 617, 528, 527, 618, 528, 527, 528, 
	619, 527, 620, 528, 527, 621, 528, 527, 
	622, 528, 527, 623, 528, 527, 624, 528, 
	527, 625, 528, 527, 626, 528, 527, 627, 
	528, 527, 546, 528, 527, 528, 629, 527, 
	528, 630, 527, 528, 631, 527, 528, 632, 
	527, 528, 633, 527, 528, 634, 527, 528, 
	635, 527, 528, 636, 527, 528, 637, 527, 
	528, 638, 527, 528, 639, 527, 528, 640, 
	527, 528, 641, 527, 528, 13, 527, 643, 
	0, 13, 0, 0, 0
};

static const unsigned char _lexer_trans_actions[] = {
	29, 0, 54, 0, 5, 1, 0, 29, 
	1, 35, 0, 43, 0, 43, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 149, 126, 
	57, 110, 23, 0, 29, 54, 0, 5, 
	1, 0, 29, 1, 35, 0, 43, 0, 
	43, 0, 43, 139, 48, 9, 106, 11, 
	0, 134, 45, 45, 45, 3, 122, 33, 
	33, 33, 0, 122, 33, 33, 33, 0, 
	122, 33, 0, 33, 0, 102, 7, 7, 
	43, 54, 0, 0, 43, 114, 25, 0, 
	54, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 43, 43, 
	43, 43, 0, 27, 118, 27, 27, 51, 
	27, 0, 54, 0, 1, 0, 43, 0, 
	0, 0, 43, 54, 37, 37, 87, 37, 
	37, 43, 0, 39, 0, 43, 0, 0, 
	54, 0, 0, 39, 0, 0, 96, 54, 
	0, 93, 90, 41, 96, 90, 99, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 144, 57, 54, 0, 84, 54, 0, 
	81, 81, 0, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 54, 0, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 54, 21, 0, 63, 130, 31, 
	60, 57, 31, 63, 57, 66, 31, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 0, 43, 
	0, 43, 0, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	43, 0, 43, 0, 43, 0, 43, 0, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 144, 57, 
	54, 0, 84, 54, 0, 78, 33, 84, 
	78, 0, 0, 0, 54, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 54, 19, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	19, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 54, 19, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 54, 0, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 19, 0, 144, 57, 54, 0, 84, 
	54, 0, 75, 33, 84, 75, 0, 0, 
	0, 54, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 54, 
	17, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 17, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 54, 0, 17, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 54, 17, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 54, 0, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 17, 0, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 144, 57, 54, 0, 
	84, 54, 0, 72, 33, 84, 72, 0, 
	0, 0, 54, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	54, 15, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 15, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 54, 0, 15, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 54, 15, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 54, 0, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 15, 0, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 0, 43, 0, 43, 
	0, 43, 0, 43, 144, 57, 54, 0, 
	84, 54, 0, 69, 33, 69, 0, 0, 
	0, 54, 0, 0, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 54, 13, 0, 
	0, 54, 0, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	54, 0, 13, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 54, 
	0, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 0, 0, 54, 
	0, 0, 54, 0, 0, 54, 0, 0, 
	54, 0, 0, 54, 0, 0, 54, 0, 
	0, 54, 0, 0, 54, 13, 0, 0, 
	43, 0, 43, 0, 0
};

static const unsigned char _lexer_eof_actions[] = {
	0, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43, 43, 43, 43, 
	43, 43, 43, 43, 43
};

static const int lexer_start = 1;
static const int lexer_first_final = 644;
static const int lexer_error = 0;

static const int lexer_en_main = 1;


#line 258 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"

static VALUE 
unindent(VALUE con, int start_col)
{
  VALUE re;
  /* Gherkin will crash gracefully if the string representation of start_col pushes the pattern past 32 characters */
  char pat[32]; 
  snprintf(pat, 32, "^[\t ]{0,%d}", start_col); 
  re = rb_reg_regcomp(rb_str_new2(pat));
  rb_funcall(con, rb_intern("gsub!"), 2, re, rb_str_new2(""));

  return Qnil;

}

static void 
store_kw_con(VALUE listener, const char * event_name, 
             const char * keyword_at, size_t keyword_length, 
             const char * at,         size_t length, 
             int current_line)
{
  VALUE con = Qnil, kw = Qnil;
  kw = ENCODED_STR_NEW(keyword_at, keyword_length);
  con = ENCODED_STR_NEW(at, length);
  rb_funcall(con, rb_intern("strip!"), 0);
  rb_funcall(listener, rb_intern(event_name), 3, kw, con, INT2FIX(current_line)); 
}

static void
store_multiline_kw_con(VALUE listener, const char * event_name,
                      const char * keyword_at, size_t keyword_length,
                      const char * at,         size_t length,
                      int current_line, int start_col)
{
  VALUE split;
  VALUE con = Qnil, kw = Qnil, name = Qnil, desc = Qnil;

  kw = ENCODED_STR_NEW(keyword_at, keyword_length);
  con = ENCODED_STR_NEW(at, length);

  unindent(con, start_col);
  
  split = rb_str_split(con, "\n");

  name = rb_funcall(split, rb_intern("shift"), 0);
  desc = rb_ary_join(split, rb_str_new2( "\n" ));

  if( name == Qnil ) 
  {
    name = rb_str_new2("");
  }
  if( rb_funcall(desc, rb_intern("size"), 0) == 0) 
  {
    desc = rb_str_new2("");
  }
  rb_funcall(name, rb_intern("strip!"), 0);
  rb_funcall(desc, rb_intern("rstrip!"), 0);
  rb_funcall(listener, rb_intern(event_name), 4, kw, name, desc, INT2FIX(current_line)); 
}

static void 
store_attr(VALUE listener, const char * attr_type,
           const char * at, size_t length, 
           int line)
{
  VALUE val = ENCODED_STR_NEW(at, length);
  rb_funcall(listener, rb_intern(attr_type), 2, val, INT2FIX(line));
}
static void 
store_docstring_content(VALUE listener, 
          int start_col, 
          const char *type_at, size_t type_length,
          const char *at, size_t length, 
          int current_line)
{
  VALUE re2;
  VALUE unescape_escaped_quotes;
  VALUE con = ENCODED_STR_NEW(at, length);
  VALUE con_type = ENCODED_STR_NEW(type_at, type_length);

  unindent(con, start_col);

  re2 = rb_reg_regcomp(rb_str_new2("\r\\Z"));
  unescape_escaped_quotes = rb_reg_regcomp(rb_str_new2("\\\\\"\\\\\"\\\\\""));
  rb_funcall(con, rb_intern("sub!"), 2, re2, rb_str_new2(""));
  rb_funcall(con_type, rb_intern("strip!"), 0);
  rb_funcall(con, rb_intern("gsub!"), 2, unescape_escaped_quotes, rb_str_new2("\"\"\""));
  rb_funcall(listener, rb_intern("doc_string"), 3, con_type, con, INT2FIX(current_line));
}
static void 
raise_lexer_error(const char * at, int line)
{ 
  rb_raise(rb_eGherkinLexingError, "Lexing error on line %d: '%s'. See http://wiki.github.com/cucumber/gherkin/lexingerror for more information.", line, at);
}

static void lexer_init(lexer_state *lexer) {
  lexer->content_start = 0;
  lexer->content_end = 0;
  lexer->content_len = 0;
  lexer->docstring_content_type_start = 0;
  lexer->docstring_content_type_end = 0;
  lexer->mark = 0;
  lexer->keyword_start = 0;
  lexer->keyword_end = 0;
  lexer->next_keyword_start = 0;
  lexer->line_number = 1;
  lexer->last_newline = 0;
  lexer->final_newline = 0;
  lexer->start_col = 0;
}

static VALUE CLexer_alloc(VALUE klass)
{
  VALUE obj;
  lexer_state *lxr = ALLOC(lexer_state);
  lexer_init(lxr);

  obj = Data_Wrap_Struct(klass, NULL, -1, lxr);

  return obj;
}

static VALUE CLexer_init(VALUE self, VALUE listener)
{
  lexer_state *lxr; 
  rb_iv_set(self, "@listener", listener);
  
  lxr = NULL;
  DATA_GET(self, lexer_state, lxr);
  lexer_init(lxr);
  
  return self;
}

static VALUE CLexer_scan(VALUE self, VALUE input)
{
  VALUE input_copy;
  char *data;
  size_t len;
  VALUE listener = rb_iv_get(self, "@listener");

  lexer_state *lexer;
  lexer = NULL;
  DATA_GET(self, lexer_state, lexer);

  input_copy = rb_str_dup(input);

  rb_str_append(input_copy, rb_str_new2("\n%_FEATURE_END_%"));
  data = RSTRING_PTR(input_copy);
  len = RSTRING_LEN(input_copy);
  
  if (len == 0) { 
    rb_raise(rb_eGherkinLexingError, "No content to lex.");
  } else {

    const char *p, *pe, *eof;
    int cs = 0;
    
    VALUE current_row = Qnil;

    p = data;
    pe = data + len;
    eof = pe;
    
    assert(*pe == '\0' && "pointer does not end on NULL");
    
    
#line 1353 "ext/gherkin_lexer_hi/gherkin_lexer_hi.c"
	{
	cs = lexer_start;
	}

#line 425 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
    
#line 1360 "ext/gherkin_lexer_hi/gherkin_lexer_hi.c"
	{
	int _klen;
	unsigned int _trans;
	const char *_acts;
	unsigned int _nacts;
	const char *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_keys = _lexer_trans_keys + _lexer_key_offsets[cs];
	_trans = _lexer_index_offsets[cs];

	_klen = _lexer_single_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( (*p) < *_mid )
				_upper = _mid - 1;
			else if ( (*p) > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _lexer_range_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( (*p) < _mid[0] )
				_upper = _mid - 2;
			else if ( (*p) > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += ((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	cs = _lexer_trans_targs[_trans];

	if ( _lexer_trans_actions[_trans] == 0 )
		goto _again;

	_acts = _lexer_actions + _lexer_trans_actions[_trans];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 )
	{
		switch ( *_acts++ )
		{
	case 0:
#line 83 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
		MARK(content_start, p);
    lexer->current_line = lexer->line_number;
    lexer->start_col = lexer->content_start - lexer->last_newline - (lexer->keyword_end - lexer->keyword_start) + 2;
  }
	break;
	case 1:
#line 89 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    MARK(content_start, p);
  }
	break;
	case 2:
#line 93 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    lexer->current_line = lexer->line_number;
    lexer->start_col = p - data - lexer->last_newline;
  }
	break;
	case 3:
#line 98 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    int len = LEN(content_start, PTR_TO(final_newline));
    int type_len = LEN(docstring_content_type_start, PTR_TO(docstring_content_type_end));

    if (len < 0) len = 0;
    if (type_len < 0) len = 0;

    store_docstring_content(listener, lexer->start_col, PTR_TO(docstring_content_type_start), type_len, PTR_TO(content_start), len, lexer->current_line);
  }
	break;
	case 4:
#line 108 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{ 
    MARK(docstring_content_type_start, p);
  }
	break;
	case 5:
#line 112 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{ 
    MARK(docstring_content_type_end, p);
  }
	break;
	case 6:
#line 116 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    STORE_KW_END_CON(feature);
  }
	break;
	case 7:
#line 120 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    STORE_KW_END_CON(background);
  }
	break;
	case 8:
#line 124 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    STORE_KW_END_CON(scenario);
  }
	break;
	case 9:
#line 128 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    STORE_KW_END_CON(scenario_outline);
  }
	break;
	case 10:
#line 132 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    STORE_KW_END_CON(examples);
  }
	break;
	case 11:
#line 136 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    store_kw_con(listener, "step",
      PTR_TO(keyword_start), LEN(keyword_start, PTR_TO(keyword_end)),
      PTR_TO(content_start), LEN(content_start, p), 
      lexer->current_line);
  }
	break;
	case 12:
#line 143 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    STORE_ATTR(comment);
    lexer->mark = 0;
  }
	break;
	case 13:
#line 148 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    STORE_ATTR(tag);
    lexer->mark = 0;
  }
	break;
	case 14:
#line 153 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    lexer->line_number += 1;
    MARK(final_newline, p);
  }
	break;
	case 15:
#line 158 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    MARK(last_newline, p + 1);
  }
	break;
	case 16:
#line 162 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    if (lexer->mark == 0) {
      MARK(mark, p);
    }
  }
	break;
	case 17:
#line 168 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    MARK(keyword_end, p);
    MARK(keyword_start, PTR_TO(mark));
    MARK(content_start, p + 1);
    lexer->mark = 0;
  }
	break;
	case 18:
#line 175 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    MARK(content_end, p);
  }
	break;
	case 19:
#line 179 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    p = p - 1;
    lexer->current_line = lexer->line_number;
    current_row = rb_ary_new();
  }
	break;
	case 20:
#line 185 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
		MARK(content_start, p);
  }
	break;
	case 21:
#line 189 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    VALUE re_pipe, re_newline, re_backslash;
    VALUE con = ENCODED_STR_NEW(PTR_TO(content_start), LEN(content_start, p));
    rb_funcall(con, rb_intern("strip!"), 0);
    re_pipe      = rb_reg_regcomp(rb_str_new2("\\\\\\|"));
    re_newline   = rb_reg_regcomp(rb_str_new2("\\\\n"));
    re_backslash = rb_reg_regcomp(rb_str_new2("\\\\\\\\"));
    rb_funcall(con, rb_intern("gsub!"), 2, re_pipe,      rb_str_new2("|"));
    rb_funcall(con, rb_intern("gsub!"), 2, re_newline,   rb_str_new2("\n"));
    rb_funcall(con, rb_intern("gsub!"), 2, re_backslash, rb_str_new2("\\"));

    rb_ary_push(current_row, con);
  }
	break;
	case 22:
#line 203 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    rb_funcall(listener, rb_intern("row"), 2, current_row, INT2FIX(lexer->current_line));
  }
	break;
	case 23:
#line 207 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    int line;
    if (cs < lexer_first_final) {
      size_t count = 0;
      VALUE newstr_val;
      char *newstr;
      int newstr_count = 0;        
      size_t len;
      const char *buff;
      if (lexer->last_newline != 0) {
        len = LEN(last_newline, eof);
        buff = PTR_TO(last_newline);
      } else {
        len = strlen(data);
        buff = data;
      }

      /* Allocate as a ruby string so that it gets cleaned up by GC */
      newstr_val = rb_str_new(buff, len);
      newstr = RSTRING_PTR(newstr_val);


      for (count = 0; count < len; count++) {
        if(buff[count] == 10) {
          newstr[newstr_count] = '\0'; /* terminate new string at first newline found */
          break;
        } else {
          if (buff[count] == '%') {
            newstr[newstr_count++] = buff[count];
            newstr[newstr_count] = buff[count];
          } else {
            newstr[newstr_count] = buff[count];
          }
        }
        newstr_count++;
      }

      line = lexer->line_number;
      lexer_init(lexer); /* Re-initialize so we can scan again with the same lexer */
      raise_lexer_error(newstr, line);
    } else {
      rb_funcall(listener, rb_intern("eof"), 0);
    }
  }
	break;
#line 1650 "ext/gherkin_lexer_hi/gherkin_lexer_hi.c"
		}
	}

_again:
	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	if ( p == eof )
	{
	const char *__acts = _lexer_actions + _lexer_eof_actions[cs];
	unsigned int __nacts = (unsigned int) *__acts++;
	while ( __nacts-- > 0 ) {
		switch ( *__acts++ ) {
	case 23:
#line 207 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"
	{
    int line;
    if (cs < lexer_first_final) {
      size_t count = 0;
      VALUE newstr_val;
      char *newstr;
      int newstr_count = 0;        
      size_t len;
      const char *buff;
      if (lexer->last_newline != 0) {
        len = LEN(last_newline, eof);
        buff = PTR_TO(last_newline);
      } else {
        len = strlen(data);
        buff = data;
      }

      /* Allocate as a ruby string so that it gets cleaned up by GC */
      newstr_val = rb_str_new(buff, len);
      newstr = RSTRING_PTR(newstr_val);


      for (count = 0; count < len; count++) {
        if(buff[count] == 10) {
          newstr[newstr_count] = '\0'; /* terminate new string at first newline found */
          break;
        } else {
          if (buff[count] == '%') {
            newstr[newstr_count++] = buff[count];
            newstr[newstr_count] = buff[count];
          } else {
            newstr[newstr_count] = buff[count];
          }
        }
        newstr_count++;
      }

      line = lexer->line_number;
      lexer_init(lexer); /* Re-initialize so we can scan again with the same lexer */
      raise_lexer_error(newstr, line);
    } else {
      rb_funcall(listener, rb_intern("eof"), 0);
    }
  }
	break;
#line 1713 "ext/gherkin_lexer_hi/gherkin_lexer_hi.c"
		}
	}
	}

	_out: {}
	}

#line 426 "/Users/ahellesoy/github/gherkin/tasks/../ragel/i18n/hi.c.rl"

    assert(p <= pe && "data overflow after parsing execute");
    assert(lexer->content_start <= len && "content starts after data end");
    assert(lexer->mark < len && "mark is after data end");
    
    /* Reset lexer by re-initializing the whole thing */
    lexer_init(lexer);

    if (cs == lexer_error) {
      rb_raise(rb_eGherkinLexingError, "Invalid format, lexing fails.");
    } else {
      return Qtrue;
    }
  }
}

void Init_gherkin_lexer_hi()
{
  mGherkin = rb_define_module("Gherkin");
  mGherkinLexer = rb_define_module_under(mGherkin, "Lexer");
  rb_eGherkinLexingError = rb_const_get(mGherkinLexer, rb_intern("LexingError"));

  mCLexer = rb_define_module_under(mGherkin, "CLexer");
  cI18nLexer = rb_define_class_under(mCLexer, "Hi", rb_cObject);
  rb_define_alloc_func(cI18nLexer, CLexer_alloc);
  rb_define_method(cI18nLexer, "initialize", CLexer_init, 1);
  rb_define_method(cI18nLexer, "scan", CLexer_scan, 1);
}

